#include "cmd_editor_imp.h"
#include "mainframe.h"
#include "mlsmenu.h"

using namespace MLS;
using namespace MLSUTIL;

void CmdEditorImp::UpdateConfig()
{
}

void CmdEditorImp::SaveConfig()
{
}

void CmdEditorImp::Split()
{
	g_tMainFrame.Split();
}

void CmdEditorImp::NextWindow()
{
	g_tMainFrame.NextWindow();
}


void CmdEditorImp::Key_Enter()
{
	_pEditor->Key_Enter();
}

void CmdEditorImp::Key_Left()
{ 
	_pEditor->Key_Left();
}

void CmdEditorImp::Key_Right() 		
{ 
	_pEditor->Key_Right();
}

void CmdEditorImp::Key_Up()
{ 
	_pEditor->Key_Up();
}

void CmdEditorImp::Key_Down()
{ 
	_pEditor->Key_Down();
}

void CmdEditorImp::Key_Home()
{ 
	_pEditor->Key_Home();
}

void CmdEditorImp::Key_End() 		
{ 
	_pEditor->Key_End();
}

void CmdEditorImp::Key_PageUp()
{ 
	_pEditor->Key_PgUp();
}

void CmdEditorImp::Key_PageDown()
{
	_pEditor->Key_PgDn();
}

void CmdEditorImp::Key_Del()
{
	_pEditor->Key_Del();
}

void CmdEditorImp::Key_BS()
{
	_pEditor->Key_BS();
}

void CmdEditorImp::Key_Ins()
{
	_pEditor->Key_Ins();
}

void CmdEditorImp::Menu()
{
	EditorMenu		tEditorMenu;
	vector<string>	vDisableList;

	if (_pPanel->GetReader()->GetReaderName() == "file")
	{
		vDisableList.push_back("Cmd_FtpClose");
	}
	else if (_pPanel->GetReader()->GetReaderName() == "ftp")
	{
		vDisableList.push_back("Cmd_FtpConn");
	}
	else
	{
		vDisableList.push_back("Cmd_FtpConn");
		vDisableList.push_back("Cmd_FtpClose");
	}

	tEditorMenu.SetDisable(vDisableList);
	tEditorMenu.SetEditor( _pEditor );
	tEditorMenu.Create();
	tEditorMenu.Do();

	g_tMainFrame.Refresh(false);
	if (tEditorMenu.GetCurCmd().size() != 0)
	{
		g_Log.Write("Menu Run [%s]", tEditorMenu.GetCurCmd().c_str());
		g_tMainFrame.GetCommand()->Execute(tEditorMenu.GetCurCmd());
	}
}

void CmdEditorImp::Quit()
{
	_pEditor->Quit();
	g_tMainFrame.SetActiveViewType(PANEL);
	g_tMainFrame.Refresh(false);
}

void CmdEditorImp::CopyClip()
{
	_pEditor->Copy();
}

void CmdEditorImp::CutClip()
{
	_pEditor->Cut();
}

void CmdEditorImp::PasteClip()
{
	_pEditor->Paste();
}

void CmdEditorImp::Undo()
{
	_pEditor->Undo();
}

void	CmdEditorImp::Key_ESC()
{
	_pEditor->Key_ESC(); 
}

void	CmdEditorImp::Refresh()
{
	_pEditor->Refresh();
}

void	CmdEditorImp::FileNew()
{
	_pEditor->FileNew();
}

void	CmdEditorImp::FileSave()
{
	_pEditor->FileSave();
}

void	CmdEditorImp::FileSaveAs()
{
	_pEditor->FileSaveAs();
}

void	CmdEditorImp::LineNumberView()
{
	_pEditor->LineNumberView();
}

void	CmdEditorImp::VimView()
{
	if ( YNBox(gettext("Vim View"), 
						gettext("Do you wan't vi editor ?"), 
						true) == false) return;
	
	string sFileName = _pEditor->GetFileName();
	if (sFileName.empty()) return;

	Quit();

	if (g_tCfg.GetValue("Default", "ExtEditor").empty())
		sFileName = "vi " + sFileName;
	else
		sFileName = g_tCfg.GetValue("Default", "ExtEditor") + " " + sFileName;
		
	g_tMainFrame.GetCommand()->ParseAndRun(sFileName, false);
}
